Unit vinfo;

{$MODE objfpc}

Interface

Uses
  Classes, SysUtils, resource, versiontypes, versionresource;

Type
  { TVersionInfo }

  TVersionInfo = Class
  private
    FVersResource: TVersionResource;
    Function GetFixedInfo: TVersionFixedInfo;
    Function GetStringFileInfo: TVersionStringFileInfo;
    Function GetVarFileInfo: TVersionVarFileInfo;
  public
    Constructor Create;
    Destructor Destroy; override;

    Procedure Load(Instance: THandle);
    Property FixedInfo: TVersionFixedInfo read GetFixedInfo;
    Property StringFileInfo: TVersionStringFileInfo read GetStringFileInfo;
    Property VarFileInfo: TVersionVarFileInfo read GetVarFileInfo;
  End;

Implementation

{ TVersionInfo }

Function TVersionInfo.GetFixedInfo: TVersionFixedInfo;
Begin
  Result := FVersResource.FixedInfo;
End;

Function TVersionInfo.GetStringFileInfo: TVersionStringFileInfo;
Begin
  Result := FVersResource.StringFileInfo;
End;

Function TVersionInfo.GetVarFileInfo: TVersionVarFileInfo;
Begin
  Result := FVersResource.VarFileInfo;
End;

Constructor TVersionInfo.Create;
Begin
  Inherited Create;
  FVersResource := TVersionResource.Create;
End;

Destructor TVersionInfo.Destroy;
Begin
  FVersResource.Free;
  Inherited Destroy;
End;

Procedure TVersionInfo.Load(Instance: THandle);
Var
  Stream: TResourceStream;
Begin
  Stream := TResourceStream.CreateFromID(Instance, 1, PChar(RT_VERSION));
  Try
    FVersResource.SetCustomRawDataStream(Stream);
    // access some property to load from the stream
    FVersResource.FixedInfo;
    // clear the stream
    FVersResource.SetCustomRawDataStream(Nil);
  Finally
    Stream.Free;
  End;
End;

End.
